<?php
namespace Teknisa\EST\Modules\Relatorios\Services;

use Teknisa\Libs\Util\DateUtil;

class Est32200ProdutosSemMovimentacao {

    protected $Est32200Factory;

	public function __construct($Est32200Factory) {
		$this->Est32200Factory = $Est32200Factory;
	}

	public function buildDataSet($row) {
		$rowForDataSet = array();
		$dataProcess = $this->Est32200Factory->getDataProcess($row[0]['CDFILIAL'], $row[0]['NRORG']);
		$dataProcess = $dataProcess[0]['DTPROCESSA'];
		for ($i=0; $i < count($row) ; $i++) {
			$auxRow = array();
			$result = $this->Est32200Factory->selectItlanctoest($row[$i]['CDFILIAL'], $row[$i]['CDALMOXARIFE'], $row[$i]['CDLOCALESTOQ'], $row[$i]['NRLOTEESTQ'], $row[$i]['NRSUBLOTE'], $row[$i]['IDTIPOMOVI'], $row[$i]['CDPRODUTO'], $row[$i]['NRORG'], $row[$i]['DTLIMITE']);
			if(!empty($result)){
				$auxRow['CDARVPROD'] = $row[$i]['CDARVPROD'];
				$auxRow['CDFILIMOVI'] = $row[$i]['CDFILIAL'];
				$auxRow['DTLANCMOVI'] = $result[0]['DTLANCMOVI'];
				$auxRow['NRDIAS'] = $this->buildNrdias($dataProcess, $result[0]['DTLANCMOVI']);
				$auxRow['IDTIPOMOVI'] = $result[0]['IDTIPOMOVI'];
				$auxRow['NMPRODUTO'] = $row[$i]['NMPRODUTO'];
				$auxRow['NRLANCESTQ'] = $result[0]['NRLANCESTQ'];
				$auxRow['NRLOTEESTQ'] = $row[$i]['NRLOTEESTQ'].' '.$row[$i]['NRSUBLOTE'];
				$auxRow['QTESTOQDIA'] = $row[$i]['QTESTOQDIA'];
				$auxRow['SGUNIDADE'] = $row[$i]['SGUNIDADE'];
				$auxRow['NRORG'] = $row[$i]['NRORG'];
				$rowForDataSet[] = $auxRow;
			}
		}
		return $rowForDataSet;
	}

	public function buildNrdias($dataProcess, $dataMovi){
		$nrDias = DateUtil::getQtdeDiasEntre($dataProcess, substr($dataMovi, 0, 10));
		if($nrDias < 0){
			$nrDias = $nrDias * -1;
		}
		return $nrDias;
	}

	public function buildParametersByRelatorio($requestRow, $parameterMapping){
		$reportStrategy = array (
	        'ReportName' => $requestRow['REPORT_NAME'],
	        'ParametersRow' =>array ()
	    );
		$row = array();
		foreach ($parameterMapping as $fieldName => $paramName) {
	       	if ($requestRow->has($fieldName)) {
	           	$row[$paramName] = $requestRow->get($fieldName);
	       	}
		}
		$reportStrategy['ParametersRow'] = $row;
		return $reportStrategy;
	}
}