var Est95100_AnaliseInventarioCego_Controller = function(ZHPromise, metaDataFactory, templateManager, ScreenService, ZhLayoutPreferences, MessageService, General, EstUtil, ZhFilterPreferences, Est95100_AnaliseInventarioCego_Services) {

    //this function sets initial values for fields in te filter
    this.setInitialParams = (widget) => {

        let SetTime = setInterval((time) => {
            let levels = General.getLevelByMask("GER_CDPICTPROD", 1);
            let nivelField = widget.getField("NVTOT");
            let data = [];

            const currentRow = widget.currentRow;
            const dtInicial = getLocalVar('DTPROCESSA');
            const dtFinal = moment().endOf('month').format('DD/MM/YYYY');

            levels.forEach((level) => {
                data.push({ NVTOT: level.nivel });
            });
            nivelField.dataSource.data = data;

            currentRow.NMRELATORIO = "EST951001";
            currentRow.ORDENACAO = "1";
            currentRow.DTCONTAGEM = { "start": dtInicial, "end": dtFinal, "formattedStart": dtInicial, "formattedEnd": dtFinal };

            Est95100_AnaliseInventarioCego_Services.getFilialLogada().then((success) => {

                const result = success.dataset.filial_paramfilial_tipocusto[0];
                currentRow.CDFILIAL = [];
                currentRow.CDFILIAL.push(result.CDFILIAL);
                currentRow.NMFILIAL = [];
                currentRow.NMFILIAL.push(result.NMFILIAL);
                currentRow.IDUTILALMOX = result.IDUTILALMOX;
                currentRow.IDUTILLCESTQ = result.IDUTILLCESTQ;
                this.onChangeReport(widget);
                clearInterval(SetTime);
            });
        }, 1000);
    };

    // It manages fields status on change report 
    this.onChangeReport = function(widget) {
        const currentRow = widget.currentRow;
        const grupoField = widget.getField('NMGRUPPROD');
        const totalizacaoField = widget.getField('NVTOT');
        const ordenacaoField = widget.getField('ORDENACAO');

        this.onChangeUnidade(widget);

        if (currentRow.NMRELATORIO == 'EST951002') {
            grupoField.readOnly = false;
            grupoField.validations = { "required": { "message": "Campo obrigatório" } };

            delete(totalizacaoField.validations);
            totalizacaoField.readOnly = true;
            totalizacaoField.clearValue();

            delete(ordenacaoField.validations);
            ordenacaoField.readOnly = true;
            ordenacaoField.clearValue();

        }
        else {
            totalizacaoField.readOnly = false;
            totalizacaoField.validations = { "required": { "message": "Campo obrigatório" } };

            ordenacaoField.readOnly = false;
            ordenacaoField.validations = { "required": { "message": "Campo obrigatório" } };

            delete(grupoField.validations);
            grupoField.readOnly = true;
            grupoField.clearValue();
        }

        grupoField.reload();
        ordenacaoField.reload();
        totalizacaoField.reload();
    };

    // It manages fields status on change unity 
    this.onChangeUnidade = function(widget) {
        const unidadeField = widget.getField('NMFILIAL');
        const almoxField = widget.getField('DSALMOXARIFE');
        const localField = widget.getField('DSLOCALESTOQ');
        const grupoField = widget.getField('NMGRUPPROD');
        const currentRow = widget.currentRow;

        if (currentRow.NMFILIAL.length == 1) {
            if (currentRow.IDUTILALMOX == 'S') {
                //almoxField.validations = { "required": { "message": "Campo obrigatório" } };
                almoxField.readOnly = false;
                if (currentRow.IDUTILLCESTQ == 'S') {
                    //localField.validations = { "required": { "message": "Campo obrigatório" } };
                    localField.readOnly = false;
                }
                else {
                    //delete(localField.validations);
                    localField.readOnly = true;
                }
            }
            else {
                delete(almoxField.validations);
                almoxField.readOnly = true;

                //delete(localField.validations);
                localField.readOnly = true;
            }
        }
        else {
            //delete(almoxField.validations);
            almoxField.readOnly = true;

            //delete(localField.validations);
            localField.readOnly = true;

            delete(grupoField.validations);
            grupoField.readOnly = true;

            if (currentRow.NMFILIAL.length == 0) {
                currentRow.CDALMOXARIFE = '';
                currentRow.DSALMOXARIFE = '';
                currentRow.CDLOCALESTOQ = '';
                currentRow.DSLOCALESTOQ = '';
                currentRow.CDGRUPPROD = '';
                currentRow.NMGRUPPROD = '';
            }
        }
        unidadeField.reload();
    };

    // It manages fields status on change almoxarife field 
    this.onChangeAlmox = function(widget) {
        const currentRow = widget.currentRow;
        const localField = widget.getField("DSLOCALESTOQ");
        currentRow.DSLOCALESTOQ = null;
        if (currentRow.IDUTILLCESTQ == 'S') {
            currentRow.CDLOCALESTOQ = null;
            if (currentRow.CDALMOXARIFE) {
                localField.readOnly = false;
                localField.reload();
            }
            else {
                localField.readOnly = true;
            }
        }
    };

    // It checks if the final product is smaller than initial product
    this.checkProductRange = function(field) {
        const currentRow = field.widget.currentRow;

        if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if (!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                MessageService.showMessageByCode("PRODUTO_INICIAL_MAIOR_FINAL");
            }
        }
    };

    // It manages report generation
    this.onGenerateReport = function(widget, format) {
        const { currentRow } = widget;
        currentRow.__FORMAT = format;

        if (widget.isValid()) {
            General.openReport("est_estoqueCego#/analiseInventario", currentRow.NMRELATORIO, currentRow);
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est95100_AnaliseInventarioCego_Controller', Est95100_AnaliseInventarioCego_Controller);
});
